Loading...
Searching...
No Matches
casacore::Gaussian2DParam< T > Class Template Reference
Functionals_module_internal_classes

More...

`#include <Gaussian2DParam.h>`

## Public Types

enum | { HEIGHT , XCENTER , YCENTER , YWIDTH , RATIO , PANGLE }
Public Types inherited from casacore::Function< T, U >
typedef FunctionTraits< T >::ArgType | ArgType
typedef const ArgType * | FunctionArg

## Public Member Functions

| Gaussian2DParam ()
| Constructs the two dimensional Gaussians.
| Gaussian2DParam (const T &height, const Vector< T > &center, const Vector< T > &width, const T &pa)
| Gaussian2DParam (const T &height, const T &xCenter, const T &yCenter, const T &majorAxis, const T &axialRatio, const T &pa)
| Gaussian2DParam (const Gaussian2DParam< T > &other)
| Copy constructor (deep copy).
template<class W>
| Gaussian2DParam (const Gaussian2DParam< W > &other)
Gaussian2DParam< T > & | operator= (const Gaussian2DParam< T > &other)
| Copy assignment (deep copy).
virtual | ~Gaussian2DParam ()
| Destructor.
virtual uInt | ndim () const
| Variable dimensionality.
virtual const String & | name () const
| Give name of function.
T | height () const
| Get or set the peak height of the Gaussian.
void | setHeight (const T &height)
T | flux () const
| Get or set the analytical integrated area underneath the Gaussian.
void | setFlux (const T &flux)
Vector< T > | center () const
| Get or set the center ordinate of the Gaussian.
void | setCenter (const Vector< T > &center)
T | xCenter () const
void | setXcenter (const T &cnter)
T | yCenter () const
void | setYcenter (const T &cnter)
Vector< T > | width () const
| Set or get the FWHM of the Gaussian.
void | setWidth (const Vector< T > &width)
T | majorAxis () const
void | setMajorAxis (const T &width)
T | minorAxis () const
void | setMinorAxis (const T &width)
T | axialRatio () const
void | setAxialRatio (const T &axialRatio)
T | PA () const
| Set/get the rotation angle (orientation) of the Gaussian.
void | setPA (const T &pa)
Public Member Functions inherited from casacore::Function< T, U >
| Function ()
| Constructors.
| Function (const uInt n)
| Function (const Vector< T > &in)
| Function (const FunctionParam< T > &other)
template<class W, class X>
| Function (const Function< W, X > &other)
virtual | ~Function ()
| Destructor.
uInt | nparameters () const
| Returns the number of parameters.
virtual U | eval (FunctionArg x) const =0
| Evaluate the function object.
T & | operator[] (const uInt n)
| Manipulate the nth parameter (0-based) with no index check.
const T & | operator[] (const uInt n) const
virtual U | operator() () const
| Evaluate this function object at xor at x, y.
virtual U | operator() (const ArgType &x) const
virtual U | operator() (const Vector< ArgType > &x) const
virtual U | operator() (FunctionArg x) const
virtual U | operator() (const ArgType &x, const ArgType &y) const
virtual U | operator() (const ArgType &x, const ArgType &y, const ArgType &z) const
Bool & | mask (const uInt n)
| Manipulate the mask associated with the nth parameter (e.g.
const Bool & | mask (const uInt n) const
const FunctionParam< T > & | parameters () const
| Return the parameter interface.
FunctionParam< T > & | parameters ()
const Vector< ArgType > & | argp () const
| Get arg_p and parset_p.
Bool | parsetp () const
void | lockParam ()
| Compiler cannot always find the correct 'const' version of parameter access.
void | unlockParam ()
virtual void | setMode (const RecordInterface &mode)
| get/set the function mode.
virtual void | getMode (RecordInterface &mode) const
virtual Bool | hasMode () const
| return True if the implementing function supports a mode.
ostream & | print (ostream &os) const
| Print the function (i.e.
virtual Function< T, U > * | clone () const =0
| Return a copy of this object from the heap.
virtual Function< typename FunctionTraits< T >::DiffType > * | cloneAD () const
virtual Function< typename FunctionTraits< T >::BaseType > * | cloneNonAD () const
Public Member Functions inherited from casacore::Functional< FunctionTraits< T >::ArgType, T >
virtual | ~Functional ()
| Destructor.
virtual T | operator() (const FunctionTraits< T >::ArgType &x) const=0
| Map a Domain x into a Range y value.
Public Member Functions inherited from casacore::Functional< Vector< FunctionTraits< T >::ArgType >, T >
virtual | ~Functional ()
| Destructor.
virtual T | operator() (const Vector< FunctionTraits< T >::ArgType > &x) const=0
| Map a Domain x into a Range y value.

## Protected Attributes

T | fwhm2int
| Constant to scale halfwidth at 1/e to FWHM.
T | thePA
| cached vale of the PA
T | theSpa
| cached values of the cos and sine of thePA
T | theCpa
T | theXwidth
| cached vale of the Xwidth = ratio*theYwidth;
Protected Attributes inherited from casacore::Function< T, U >
FunctionParam< T > | param_p
| The parameters and masks.
Vector< ArgType > | arg_p
| Aid for non-contiguous argument storage.
Bool | parset_p
| Indicate parameter written.
Bool | locked_p
| Indicate that parameters are expected to be locked from changing.

## Detailed Description

template<class T>
class casacore::Gaussian2DParam< T >

Parameter handling for 2 dimensional Gaussian class

### Intended use:

Internal

### Review Status

Reviewed By:
  mwieringa
Date Reviewed:
  1996/10/d24
Test programs:
  tGaussian2D

### Prerequisite

- FunctionParam class
- Function class

### Etymology

A 2-dimensional Gaussian's parameters.

### Synopsis

A Gaussian2D is described by a height, center, and width, and position angle.

The width of the Gaussian (for the constructors or the setWidth function) is always specified in terms of the full width at half maximum (FWHM). The major axis is parallel with the y axis when the position angle is zero. The major axis will always have a larger width than the minor axis.

It is not possible to set the width of the major axis (using the setMajorAxis function) smaller than the width of the current minor axis. Similarly it is not possible to set the width of the minor axis (using the setMinorAxis function) to be larger than the current major axis. Exceptions are thrown if these rules are violated or if either the major or minor axis is set to a non-positive width. To set both axis in one hit use the setWidth function. All these restrictions can be overcome when the parameters interface is used (see below).

The position angle is the angle between the y axis and the major axis and is measured counter-clockwise, so a position angle of 45 degrees rotates the major axis to the line where y=-x. The position angle is always specified and returned in radians. When using the setPA function its value must be between -2pi and + 2pi, and the returned value from the pa function will always be a value between 0 and pi.

The axial ratio can be used as an alternative to specifying the width of the minor axis. It is the ratio between the minor and major axis widths. The axial ratio is constrained to be between zero and one, and specifying something different (using setAxialRatio) will throw an exception.

The peak height of the Gaussian can be specified at construction time or by using the setHeight function. Alternatively the setFlux function can be used to implicitly set the peak height by specifying the integrated area under the Gaussian. The height (or flux) can be positive, negative or zero, as this class makes no assumptions on what quantity the height represents.

Tip: Changing the width of the Gaussian will not affect its peak height but will change its flux; So you should always set the width before setting the flux;

The parameter interface (see FunctionParam class), is used to provide an interface to the Fitting classes.

There are 6 parameters that are used to describe the Gaussian:

1. The height of the Gaussian. This is identical to the value returned using the height member function.
2. The center of the Gaussian in the x direction. This is identical to the value returned using the xCenter member function.
3. The center of the Gaussian in the y direction. This is identical to the value returned using the yCenter member function.
4. The width (FWHM) of the Gaussian on one axis. Initially this will be the major axis, but if the parameters are adjusted by a Fitting class, it may become the axis with the smaller width. To aid convergence of the non-linear fitting routines this parameter is allowed to be negative. This does not affect the shape of the Gaussian as the squares of the widths are used when evaluating the function.
5. A modified axial ratio. This parameter is the ratio of the width on the 'other' axis (which initially is the minor axis) and axis given by parameter 4. Because these internal widths are allowed to be negative and because there is no constraints on which axis is the larger one the modified axial ratio is not constrained to be between zero and one.
6. The rotation angle. This represents the angle (in radians) between the axis used by parameter 4, and the y axis, measured counterclockwise. If parameter 4 represents the major axis width then this parameter will be identical to the position angle, otherwise it will be different by 90 degrees. The tight constraints on the value of the rotation angle enforced by the setPA() function are relaxed so that any value between -6000 and 6000 is allowed. It is still interpreted in radians.

An enumeration for the HEIGHT, XCENTER, YCENTER, YWIDTH, RATIO, PANGLE parameter index is provided, enabling the setting and reading of parameters with the [] operator. The mask() methods can be used to check and set the parameter masks.

This class is in general used implicitly by the Gaussian2D class only.

Tip: Other points to bear in mind when fitting this class to measured data are:

- If you need to fit a circular Gaussian to data you MUST set the axial ratio to one, and mask the position angle and axial ratio parameters; This avoids rank deficiency in the fitting routines as the position angle is meaningless when the major and minor axis are equal;
- If fitting an elliptical Gaussian your initial model should not be a circular Gaussian;

### Example

Gaussian2D<Double> g(10.0, 0.0, 0.0, 2.0, 1.0, 0.0);
Vector<Double> x(2);
x(0) = 1.0; x(1) = 0.5;
cout << "g(" << x(0) << "," << x(1) << ") = " << g(x) << endl;
casacore::Gaussian2D
Definition Gaussian2D.h:176
casacore::Vector
Definition Vector.h:82

### Motivation

Gaussian2D objects allow us to represent models of the sky in a more conventional way than the generic interface used in the GaussianND class does.

### Template Type Argument Requirements (T)

- T should have standard numerical operators and exp() function. Current implementation only tested for real types (and AutoDiff of them).

### Thrown Exceptions

- Assertion in debug mode if attempt is made to set a negative width
- AipsError if incorrect parameter number specified.

### To Do

- Gaussians that know about their DFT's could be required eventually.

Definition at line 190 of file Gaussian2DParam.h.

## Member Enumeration Documentation

## anonymous enum

template<class T>

anonymous enum

Enumerator
HEIGHT |
XCENTER |
YCENTER |
YWIDTH |
RATIO |
PANGLE |

Definition at line 194 of file Gaussian2DParam.h.

## Constructor & Destructor Documentation

## Gaussian2DParam() [1/5]

template<class T>

casacore::Gaussian2DParam< T >::Gaussian2DParam | ( |  | ) |

Constructs the two dimensional Gaussians.

Defaults: height=1, center=0, width(FWHM)=1, pa=0.

Referenced by casacore::Gaussian2D< T >::Gaussian2D(), casacore::Gaussian2D< T >::Gaussian2D(), casacore::Gaussian2D< T >::Gaussian2D(), casacore::Gaussian2D< T >::Gaussian2D(), casacore::Gaussian2D< T >::Gaussian2D(), Gaussian2DParam(), Gaussian2DParam(), and operator=().

## Gaussian2DParam() [2/5]

template<class T>

casacore::Gaussian2DParam< T >::Gaussian2DParam | ( | const T & | height,
|  | const Vector< T > & | center,
|  | const Vector< T > & | width,
|  | const T & | pa )

References center(), height(), casacore::pa(), and width().

## Gaussian2DParam() [3/5]

template<class T>

casacore::Gaussian2DParam< T >::Gaussian2DParam | ( | const T & | height,
|  | const T & | xCenter,
|  | const T & | yCenter,
|  | const T & | majorAxis,
|  | const T & | axialRatio,
|  | const T & | pa )

References axialRatio(), height(), majorAxis(), casacore::pa(), xCenter(), and yCenter().

## Gaussian2DParam() [4/5]

template<class T>

casacore::Gaussian2DParam< T >::Gaussian2DParam | ( | const Gaussian2DParam< T > & | other | ) |

Copy constructor (deep copy).

References Gaussian2DParam().

## Gaussian2DParam() [5/5]

template<class T>
template<class W>

casacore::Gaussian2DParam< T >::Gaussian2DParam | ( | const Gaussian2DParam< W > & | other | ) |

inline

Definition at line 212 of file Gaussian2DParam.h.

References casacore::Function< T, U >::Function(), fwhm2int, Gaussian2DParam(), casacore::log(), majorAxis(), PA(), setPA(), and casacore::sqrt().

## ~Gaussian2DParam()

template<class T>

virtual casacore::Gaussian2DParam< T >::~Gaussian2DParam | ( |  | ) |

virtual

Destructor.

## Member Function Documentation

## axialRatio()

template<class T>

T casacore::Gaussian2DParam< T >::axialRatio | ( |  | ) | const

Referenced by casacore::Gaussian2D< T >::Gaussian2D(), Gaussian2DParam(), and setAxialRatio().

## center()

template<class T>

Vector< T > casacore::Gaussian2DParam< T >::center | ( |  | ) | const

Get or set the center ordinate of the Gaussian.

Referenced by casacore::Gaussian2D< T >::Gaussian2D(), Gaussian2DParam(), and setCenter().

## flux()

template<class T>

T casacore::Gaussian2DParam< T >::flux | ( |  | ) | const

Get or set the analytical integrated area underneath the Gaussian.

Use these functions as an alternative to the height functions.

Referenced by setFlux().

## height()

template<class T>

T casacore::Gaussian2DParam< T >::height | ( |  | ) | const

inline

Get or set the peak height of the Gaussian.

Definition at line 235 of file Gaussian2DParam.h.

References HEIGHT, and casacore::Function< T, U >::param_p.

Referenced by casacore::Gaussian2D< T >::Gaussian2D(), casacore::Gaussian2D< T >::Gaussian2D(), Gaussian2DParam(), Gaussian2DParam(), and setHeight().

## majorAxis()

template<class T>

T casacore::Gaussian2DParam< T >::majorAxis | ( |  | ) | const

Referenced by casacore::Gaussian2D< T >::Gaussian2D(), Gaussian2DParam(), and Gaussian2DParam().

## minorAxis()

template<class T>

T casacore::Gaussian2DParam< T >::minorAxis | ( |  | ) | const

## name()

template<class T>

virtual const String & casacore::Gaussian2DParam< T >::name | ( |  | ) | const

inline virtual

Give name of function.

Reimplemented from casacore::Function< T, U >.

Definition at line 230 of file Gaussian2DParam.h.

## ndim()

template<class T>

virtual uInt casacore::Gaussian2DParam< T >::ndim | ( |  | ) | const

inline virtual

Variable dimensionality.

Implements casacore::Function< T, U >.

Definition at line 226 of file Gaussian2DParam.h.

## operator=()

template<class T>

Gaussian2DParam< T > & casacore::Gaussian2DParam< T >::operator= | ( | const Gaussian2DParam< T > & | other | ) |

Copy assignment (deep copy).

References Gaussian2DParam().

Referenced by casacore::Gaussian2D< T >::operator=().

## PA()

template<class T>

T casacore::Gaussian2DParam< T >::PA | ( |  | ) | const

Set/get the rotation angle (orientation) of the Gaussian.

PA is given in radians counterclockwise.

Referenced by Gaussian2DParam().

## setAxialRatio()

template<class T>

void casacore::Gaussian2DParam< T >::setAxialRatio | ( | const T & | axialRatio | ) |

References axialRatio().

## setCenter()

template<class T>

void casacore::Gaussian2DParam< T >::setCenter | ( | const Vector< T > & | center | ) |

References center().

## setFlux()

template<class T>

void casacore::Gaussian2DParam< T >::setFlux | ( | const T & | flux | ) |

References flux().

## setHeight()

template<class T>

void casacore::Gaussian2DParam< T >::setHeight | ( | const T & | height | ) |

inline

Definition at line 236 of file Gaussian2DParam.h.

References HEIGHT, height(), and casacore::Function< T, U >::param_p.

## setMajorAxis()

template<class T>

void casacore::Gaussian2DParam< T >::setMajorAxis | ( | const T & | width | ) |

References width().

## setMinorAxis()

template<class T>

void casacore::Gaussian2DParam< T >::setMinorAxis | ( | const T & | width | ) |

References width().

## setPA()

template<class T>

void casacore::Gaussian2DParam< T >::setPA | ( | const T & | pa | ) |

References casacore::pa().

Referenced by Gaussian2DParam().

## setWidth()

template<class T>

void casacore::Gaussian2DParam< T >::setWidth | ( | const Vector< T > & | width | ) |

References width().

## setXcenter()

template<class T>

void casacore::Gaussian2DParam< T >::setXcenter | ( | const T & | cnter | ) |

inline

Definition at line 251 of file Gaussian2DParam.h.

References casacore::Function< T, U >::param_p, and XCENTER.

## setYcenter()

template<class T>

void casacore::Gaussian2DParam< T >::setYcenter | ( | const T & | cnter | ) |

inline

Definition at line 253 of file Gaussian2DParam.h.

References casacore::Function< T, U >::param_p, and YCENTER.

## width()

template<class T>

Vector< T > casacore::Gaussian2DParam< T >::width | ( |  | ) | const

Set or get the FWHM of the Gaussian.

Referenced by casacore::Gaussian2D< T >::Gaussian2D(), Gaussian2DParam(), setMajorAxis(), setMinorAxis(), and setWidth().

## xCenter()

template<class T>

T casacore::Gaussian2DParam< T >::xCenter | ( |  | ) | const

inline

Definition at line 250 of file Gaussian2DParam.h.

References casacore::Function< T, U >::param_p, and XCENTER.

Referenced by casacore::Gaussian2D< T >::Gaussian2D(), and Gaussian2DParam().

## yCenter()

template<class T>

T casacore::Gaussian2DParam< T >::yCenter | ( |  | ) | const

inline

Definition at line 252 of file Gaussian2DParam.h.

References casacore::Function< T, U >::param_p, and YCENTER.

Referenced by casacore::Gaussian2D< T >::Gaussian2D(), and Gaussian2DParam().

## Member Data Documentation

## fwhm2int

template<class T>

T casacore::Gaussian2DParam< T >::fwhm2int

protected

Constant to scale halfwidth at 1/e to FWHM.

Definition at line 277 of file Gaussian2DParam.h.

Referenced by Gaussian2DParam().

## theCpa

template<class T>

T casacore::Gaussian2DParam< T >::theCpa

mutable protected

Definition at line 283 of file Gaussian2DParam.h.

## thePA

template<class T>

T casacore::Gaussian2DParam< T >::thePA

mutable protected

cached vale of the PA

Definition at line 279 of file Gaussian2DParam.h.

## theSpa

template<class T>

T casacore::Gaussian2DParam< T >::theSpa

mutable protected

cached values of the cos and sine of thePA

Definition at line 282 of file Gaussian2DParam.h.

## theXwidth

template<class T>

T casacore::Gaussian2DParam< T >::theXwidth

mutable protected

cached vale of the Xwidth = ratio*theYwidth;

Definition at line 286 of file Gaussian2DParam.h.

The documentation for this class was generated from the following file:

- scimath/Functionals/Gaussian2DParam.h